/*------------------------------------------------------------------*/
/* Large LED display sample                                         */
/*------------------------------------------------------------------*/
#define LED7SEG_ENABLE  12
#define LED7SEG_DATA    11
#define LED7SEG_CLOCK   10

#define DISPLAY_ID       0     

#define CMD_NORMAL       0b00010000
#define CMD_NORMAL_DP    0b00100000
#define CMD_CODE         0b01110000
#define CMD_ID           0b10000000

#define CMD_ASCII           0
#define CMD_MAX7219         1
#define CMD_ASCII_ROTATE    2
#define CMD_MAX7219_ROTATE  3

//------------------------------------------------------------------------------
// external LARGE LED display
//------------------------------------------------------------------------------
void led7seg_write( unsigned char data )
{
  digitalWrite(LED7SEG_CLOCK,1);
  delayMicroseconds(1);
  digitalWrite(LED7SEG_ENABLE,0);
  for( unsigned char i = 0 ; i < 8 ; i++ ) {
    digitalWrite(LED7SEG_CLOCK,0);
    if( (data & 0x80) == 0x80 ) {
       digitalWrite(LED7SEG_DATA,1);
    } else {
       digitalWrite(LED7SEG_DATA,0);
    }
    data <<= 1;
    delayMicroseconds(10);  
    digitalWrite(LED7SEG_CLOCK,1);
    delayMicroseconds(10);
  }
  digitalWrite(LED7SEG_ENABLE,1);
  delayMicroseconds(15);
}

//------------------------------------------------------------------------------
// setup
//------------------------------------------------------------------------------
void setup() {
  pinMode(LED7SEG_ENABLE, OUTPUT);     
  pinMode(LED7SEG_CLOCK,  OUTPUT);     
  pinMode(LED7SEG_DATA,   OUTPUT);
  
  digitalWrite(LED7SEG_ENABLE,1);
  
  delay(1000);
  led7seg_write( CMD_ID | CMD_CODE | DISPLAY_ID );
  led7seg_write( CMD_ASCII );  
  delay(10); 
}

//------------------------------------------------------------------------------
// loop
//------------------------------------------------------------------------------
void loop() {
  for( unsigned char num = 0 ; num <=9 ; num++ ) {
    led7seg_write( CMD_ID | CMD_NORMAL_DP | DISPLAY_ID );
    led7seg_write( num + '0' );
    delay(500);
  }
}
